summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2006-12-16 00:00:28 +0000
committer Eric Hameleers <alien@slackware.com>2006-12-16 00:00:28 +0000
commitd33dbfe51939229241ba0bb1af47488dabce2907 (patch)
treea831ac00c6452660298b8fe2d7540da6c33dc86d
parent174c6f3e73e55c9ec973a69f5308ca4fc7f5657a (diff)
downloadasb-d33dbfe51939229241ba0bb1af47488dabce2907.tar.gz
asb-d33dbfe51939229241ba0bb1af47488dabce2907.tar.xz
Updated for Slackware 11 and a newer pygtk
-rwxr-xr-xpygtk/build/pygtk.SlackBuild197
1 files changed, 107 insertions, 90 deletions
diff --git a/pygtk/build/pygtk.SlackBuild b/pygtk/build/pygtk.SlackBuild
index b72fde72..b7e906b6 100755
--- a/pygtk/build/pygtk.SlackBuild
+++ b/pygtk/build/pygtk.SlackBuild
@@ -8,14 +8,16 @@
# ===========================
# By: Eric Hameleers <alien@slackware.com>
# For: pygtk
-# Descr: GTK+ bindings for Python
+# Descr: GTK+ for Python
# URL: http://www.pygtk.org/
-# Needs: Gtk+ >= 2.6 , Python >= 2.3
+# Needs:
# Changelog:
# 2.8.6-1: 06/May/2006 by Eric Hameleers <alien@slackware.com>
# * Initial build.
+# 2.10.3-1: 16/Dec/2006 by Eric Hameleers <alien@slackware.com>
+# * Update. Also reworked the SLackBuild script.
#
-# Run 'sh SlackBuild --cleanup' to build a Slackware package.
+# Run 'sh pygtk.SlackBuild --cleanup' to build a Slackware package.
# The package (.tgz) plus descriptive .txt file are created in /tmp .
# Install using 'installpkg'.
#
@@ -23,35 +25,52 @@
# --- INIT ---
# Set initial variables:
-CWD=`pwd`
-if [ "$TMP" = "" ]; then
- TMP=/tmp
-fi
PRGNAM=pygtk
-VERSION=${VERSION:-2.8.6}
+VERSION=${VERSION:-2.10.3}
ARCH=${ARCH:-i486}
-BUILD=1
+BUILD=${BUILD:-1}
DOCS="AUTHORS COPYING ChangeLog* INSTALL MAPPING NEWS PKG-INFO README \
THREADS TODO"
-# If you have more source files, list them here as SOURCE[1], SOURCE[2], etc.
-# If you know the URL for a source file, you can put that into the SRCURL[]
-# variable, and the SlackBuild script will try to download it for you.
+# Where do we look for sources?
+CWD=`pwd`
+SRCDIR=`dirname $0`
+[ "${SRCDIR:0:1}" == "." ] && SRCDIR=${CWD}/${SRCDIR}
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
-SOURCE[0]="${PRGNAM}-${VERSION}.tar.gz"
-SRCURL[0]="http://ftp.gnome.org/pub/GNOME/sources/${PRGNAM}/2.8/${PRGNAM}-${VERSION}.tar.gz"
+# Input URL: http://ftp.gnome.org/pub/GNOME/sources/pygtk/2.10/pygtk-2.10.3.tar.gz
+SOURCE="$SRCDIR/${PRGNAM}-${VERSION}.tar.gz"
+SRCURL="http://ftp.gnome.org/pub/GNOME/sources/${PRGNAM}/2.10/${PRGNAM}-${VERSION}.tar.gz"
##
## --- with a little luck, you won't have to edit below this point --- ##
##
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line $LINENO!" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Slackware 11 and up need other option (gcc > 3.3.x)
+if [ `gcc -dumpversion | tr -d '.' |cut -c 1-2` -gt 33 ]; then
+ MOPT=tune
+else
+ MOPT=cpu
+fi
+
case "$ARCH" in
- i386) SLKCFLAGS="-O2 -march=i386 -mcpu=i686"
+ i386) SLKCFLAGS="-O2 -march=i386 -m${MOPT}=i686"
SLKLDFLAGS=""; LIBDIRSUFFIX=""
;;
- i486) SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ i486) SLKCFLAGS="-O2 -march=i486 -m${MOPT}=i686"
SLKLDFLAGS=""; LIBDIRSUFFIX=""
;;
s390) SLKCFLAGS="-O2"
@@ -68,37 +87,47 @@ case "$ARCH" in
;;
esac
-PKG=$TMP/package-$PRGNAM
-
if [ ! -d $TMP/tmp-$PRGNAM ]; then
mkdir -p $TMP/tmp-$PRGNAM # location to build the source
-elif [ "$1" != "--oldbuild" ]; then
+elif [ "$P1" != "--oldbuild" ]; then
# If the "--oldbuild" parameter is present, we keep
# the old build files and continue;
# By default we remove the remnants of previous build and continue:
rm -rf $TMP/tmp-$PRGNAM/*
fi
+if [ ! -d $PKG ]; then
+ mkdir -p $PKG # place for the package to be built
+else
+ rm -rf $PKG/* # We always erase old package's contents:
+fi
+
+if [ ! -d $OUTPUT ]; then
+ mkdir -p $OUTPUT # place for the package to be saved
+fi
+
# --- SOURCE FILE AVAILABILITY ---
-for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
- if ! [ -f ${CWD}/${SOURCE[$i]} ]; then
- if ! [ "${SRCURL[$i]}" = "" ]; then
- echo "Source '${SOURCE[$i]}' not available yet... will download now:"
- wget -nv -O "${CWD}/${SOURCE[$i]}" "${SRCURL[$i]}"
- if [ $? -ne 0 ]; then
- echo "Downloading '${SOURCE[$i]}' failed... aborting the build."
- exit 1
- fi
- else
- echo "File '${SOURCE[$i]}' not available... aborting the build."
+if ! [ -f ${SOURCE} ]; then
+ if ! [ "x${SRCURL}" == "x" ]; then
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/`basename $SOURCE`"
+ echo "Source '`basename ${SOURCE}`' not available yet..."
+ echo "Will download file to `dirname $SOURCE`"
+ wget -nv -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 ]; then
+ echo "Downloading '`basename ${SOURCE}`' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
exit 1
fi
+ else
+ echo "File '`basename ${SOURCE}`' not available... aborting the build."
+ exit 1
fi
-done
+fi
-if [ "$1" == "--download" ]; then
+if [ "$P1" == "--download" ]; then
echo "Download complete."
exit 0
fi
@@ -109,25 +138,11 @@ echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"
-# Safety net 8-)
-if [ "$PKG" = "" -o "$PKG" = "/" ] ; then
- cat <<-EOT
- Your script sucks!!!
- You were about to delete the contents of your computer's hard disk!
- Please provide a value for the variable 'PKG'.
- EOT
- exit 1
-elif [ ! -d $PKG ]; then
- mkdir -p $PKG # place for the package to be built
-else
- rm -rf $PKG/* # We always erase old package's contents:
-fi
-
cd $PKG
# Explode the package framework:
-if [ -f $CWD/_$PRGNAM.tar.gz ]; then
- explodepkg $CWD/_$PRGNAM.tar.gz
+if [ -f $SRCDIR/_$PRGNAM.tar.gz ]; then
+ explodepkg $SRCDIR/_$PRGNAM.tar.gz
fi
cd $TMP/tmp-$PRGNAM
@@ -136,25 +151,28 @@ cd $TMP/tmp-$PRGNAM
# --- TARBALL EXTRACTION,PATCH,MODIFY ---
echo "Extracting the source archive(s) for $PRGNAM..."
-for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
- if `file $CWD/${SOURCE[$i]} | grep -q ": bzip2"`; then
- tar -xjvf $CWD/${SOURCE[$i]}
- elif `file $CWD/${SOURCE[$i]} | grep -qi ": zip"`; then
- unzip $CWD/${SOURCE[$i]}
- elif `file $CWD/${SOURCE[$i]} | grep -qi ": 7-zip"`; then
- 7za -x $CWD/${SOURCE[$i]}
- else
- tar -xzvf $CWD/${SOURCE[$i]}
- fi
- if [ $? -ne 0 ]; then
- echo "Error in unpacking '${SOURCE[$i]}!' Aborting..."
- exit $?
- fi
-done
-cd ${PRGNAM}-${VERSION}
+if `file ${SOURCE} | grep -q ": bzip2"`; then
+ tar -xjvf ${SOURCE} || true
+elif `file ${SOURCE} | grep -qi ": zip"`; then
+ unzip ${SOURCE} || true
+elif `file ${SOURCE} | grep -qi ": 7-zip"`; then
+ 7za -x ${SOURCE} || true
+else
+ tar -xzvf ${SOURCE} || true
+fi
+if [ $? -ne 0 ]; then
+ echo "Error in unpacking '${SOURCE}!' Aborting..."
+ exit $?
+fi
+if [ -d ${PRGNAM}-${VERSION} ]; then
+ cd ${PRGNAM}-${VERSION}
+else
+ cd ${PRGNAM}* # a little less specific
+fi
chown -R root.root *
find . -perm 777 -exec chmod 755 {} \;
+find . -perm 666 -exec chmod 644 {} \;
# --- BUILDING ---
@@ -171,18 +189,18 @@ CFLAGS="$SLKCFLAGS" \
--program-prefix="" \
--program-suffix="" \
$ARCH-slackware-linux \
- 2>&1 | tee $CWD/configure-${PRGNAM}.log
-make 2>&1 | tee $CWD/make-${PRGNAM}.log
+ 2>&1 | tee $OUTPUT/configure-${PRGNAM}.log
+make 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
#
# Install all the needed stuff to the package dir
#
-# Use installwatch if available:
-which installwatch > /dev/null 2>&1
-if [ $? == 0 ]; then
- installwatch -o $CWD/install-${PRGNAM}.log make DESTDIR=$PKG install
+# Use installwatch if available, to produce a logfile of the installation
+# process that is more easily readable:
+if `which installwatch > /dev/null 2>&1`; then
+ installwatch -o $OUTPUT/install-${PRGNAM}.log make DESTDIR=$PKG install
else
- make DESTDIR=$PKG install 2>&1 |tee $CWD/install-${PRGNAM}.log
+ make DESTDIR=$PKG install 2>&1 |tee $OUTPUT/install-${PRGNAM}.log
fi
# No need for demos here - developers will know where to get demos.
@@ -192,16 +210,15 @@ rm -rf $PKG/usr/lib/pygtk/*/demos
# --- DOCUMENTATION ---
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
-cp -a $DOCS \
- $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
chmod -R a-w $PKG/usr/doc/$PRGNAM-$VERSION/*
-# Move incorrectly installed man pages, if any
-[ -d $PKG/usr/share/man ] && \
- mv $PKG/usr/share/man $PKG/usr/ && rmdir $PKG/usr/share
# Compress the man page(s)
-[ -d $PKG/usr/man ] && \
- find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+[ -d $PKG/usr/man ] && (
+ cd $PKG/usr/man
+ find . -type f -name "*.?" -exec gzip -9f {} \;
+ for i in `find . -type l -name "*.?"` ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+ )
# Strip binaries
( cd $PKG
@@ -218,12 +235,12 @@ chmod -R o-w $PKG
# --- PACKAGE DESCRIPTION ---
mkdir -p $PKG/install
-cat $CWD/slack-desc > $PKG/install/slack-desc
-if [ -f $CWD/doinst.sh ]; then
- cat $CWD/doinst.sh > $PKG/install/doinst.sh
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+if [ -f $SRCDIR/doinst.sh ]; then
+ cat $SRCDIR/doinst.sh >> $PKG/install/doinst.sh
fi
-if [ -f $CWD/slack-requires ]; then
- cat $CWD/slack-requires > $PKG/install/slack-requires
+if [ -f $SRCDIR/slack-required ]; then
+ cat $SRCDIR/slack-required > $PKG/install/slack-required
fi
@@ -231,19 +248,19 @@ fi
# Build the package:
cd $PKG
-makepkg --linkadd y --chown n $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz \
- 2>&1 | tee $CWD/makepkg-${PRGNAM}.log
-(cd $TMP && md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz.md5)
-cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.txt
-if [ -f $PKG/install/slack-requires ]; then
- cat $PKG/install/slack-requires > $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.dep
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz \
+ 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+(cd $OUTPUT && md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz.md5)
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.txt
+if [ -f $PKG/install/slack-required ]; then
+ cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.dep
fi
# --- CLEANUP ---
# Clean up the extra stuff:
-if [ "$1" = "--cleanup" ]; then
+if [ "$P1" = "--cleanup" ]; then
rm -rf $TMP/tmp-$PRGNAM
rm -rf $PKG
fi